



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Nginx 变量漫谈（一）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Nginx 变量漫谈（一）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 13:19:01 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Nginx 的配置文件使用的就是一门微型的编程语言，许多真实世界里的 Nginx 配置文件其实就是一个一个的小程序。当然，是不是&ldquo;图灵完全的&rdquo;暂且不论，至少据我观察，它在设计上受 Perl 和 Bourne Shell 这两种语言的影响很大。在这一点上，相比 Apache 和 Lighttpd 等其他 Web 服务器的配置记法，不能不说算是 Nginx 的一大特色了。既然是编程语言，一般也就少不了&ldquo;变量&rdquo;这种东西（当然，Haskell 这样奇怪的函数式语言除外了）。</p>
<p>熟悉 Perl、Bourne Shell、C/C++ 等命令式编程语言的朋友肯定知道，变量说白了就是存放&ldquo;值&rdquo;的容器。而所谓&ldquo;值&rdquo;，在许多编程语言里，既可以是&nbsp;<code>3.14</code>&nbsp;这样的数值，也可以是&nbsp;<code>hello world</code>&nbsp;这样的字符串，甚至可以是像数组、哈希表这样的复杂数据结构。然而，在 Nginx 配置中，变量只能存放一种类型的值，因为也只存在一种类型的值，那就是字符串。</p>
<p>比如我们的&nbsp;<code>nginx.conf</code>&nbsp;文件中有下面这一行配置：</p>
<div>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://wiki.nginx.org/NginxHttpRewriteModule#set" rel="external nofollow noreferrer">set</a>&nbsp;$a&nbsp;"hello&nbsp;world";</pre>
</div>
<p>我们使用了标准&nbsp;<a href="http://wiki.nginx.org/HttpRewriteModule" rel="external nofollow noreferrer">ngx_rewrite</a>&nbsp;模块的&nbsp;<a href="http://wiki.nginx.org/HttpRewriteModule#set" rel="external nofollow noreferrer">set</a>&nbsp;配置指令对变量&nbsp;<code>$a</code>&nbsp;进行了赋值操作。特别地，我们把字符串&nbsp;<code>hello world</code>&nbsp;赋给了它。</p>
<p>我们看到，Nginx 变量名前面有一个&nbsp;<code>$</code>&nbsp;符号，这是记法上的要求。所有的 Nginx 变量在 Nginx 配置文件中引用时都须带上&nbsp;<code>$</code>&nbsp;前缀。这种表示方法和 Perl、PHP 这些语言是相似的。</p>
<p>虽然&nbsp;<code>$</code>&nbsp;这样的变量前缀修饰会让正统的&nbsp;<code>Java</code>&nbsp;和&nbsp;<code>C#</code>&nbsp;程序员不舒服，但这种表示方法的好处也是显而易见的，那就是可以直接把变量嵌入到字符串常量中以构造出新的字符串：</p>
<div>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://wiki.nginx.org/NginxHttpRewriteModule#set" rel="external nofollow noreferrer">set</a>&nbsp;$a&nbsp;hello;<br />&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://wiki.nginx.org/NginxHttpRewriteModule#set" rel="external nofollow noreferrer">set</a>&nbsp;$b&nbsp;"$a,&nbsp;$a";</pre>
</div>
<p>这里我们通过已有的 Nginx 变量&nbsp;<code>$a</code>&nbsp;的值，来构造变量&nbsp;<code>$b</code>&nbsp;的值，于是这两条指令顺序执行完之后，<code>$a</code>&nbsp;的值是<code>hello</code>，而&nbsp;<code>$b</code>&nbsp;的值则是&nbsp;<code>hello, hello</code>. 这种技术在 Perl 世界里被称为&ldquo;变量插值&rdquo;（variable interpolation），它让专门的字符串拼接运算符变得不再那么必要。我们在这里也不妨采用此术语。</p>
<p>我们来看一个比较完整的配置示例：</p>
<div>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://wiki.nginx.org/NginxHttpCoreModule#server" rel="external nofollow noreferrer">server</a>&nbsp;{<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://wiki.nginx.org/NginxHttpCoreModule#listen" rel="external nofollow noreferrer">listen</a>&nbsp;8080;<br />&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://wiki.nginx.org/NginxHttpCoreModule#location" rel="external nofollow noreferrer">location</a>&nbsp;/test&nbsp;{<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://wiki.nginx.org/NginxHttpRewriteModule#set" rel="external nofollow noreferrer">set</a>&nbsp;$foo&nbsp;hello;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;echo&nbsp;"foo:&nbsp;$foo";<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />&nbsp;&nbsp;&nbsp;&nbsp;}</pre>
</div>
<p>这个例子省略了&nbsp;<code>nginx.conf</code>&nbsp;配置文件中最外围的&nbsp;<code>http</code>&nbsp;配置块以及&nbsp;<code>events</code>&nbsp;配置块。使用&nbsp;<code>curl</code>&nbsp;这个 HTTP 客户端在命令行上请求这个&nbsp;<code>/test</code>&nbsp;接口，我们可以得到</p>
<div>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;$&nbsp;curl&nbsp;'http://localhost:8080/test'<br />&nbsp;&nbsp;&nbsp;&nbsp;foo:&nbsp;hello</pre>
</div>
<p>这里我们使用第三方&nbsp;<a href="http://wiki.nginx.org/HttpEchoModule" rel="external nofollow noreferrer">ngx_echo</a>&nbsp;模块的&nbsp;<a href="http://wiki.nginx.org/HttpEchoModule#echo" rel="external nofollow noreferrer">echo</a>&nbsp;配置指令将&nbsp;<code>$foo</code>&nbsp;变量的值作为当前请求的响应体输出。</p>
<p>我们看到，<a href="http://wiki.nginx.org/HttpEchoModule#echo" rel="external nofollow noreferrer">echo</a>&nbsp;配置指令的参数也支持&ldquo;变量插值&rdquo;。不过，需要说明的是，并非所有的配置指令都支持&ldquo;变量插值&rdquo;。事实上，指令参数是否允许&ldquo;变量插值&rdquo;，取决于该指令的实现模块。</p>
<p>如果我们想通过&nbsp;<a href="http://wiki.nginx.org/HttpEchoModule#echo" rel="external nofollow noreferrer">echo</a>&nbsp;指令直接输出含有&ldquo;美元符&rdquo;（<code>$</code>）的字符串，那么有没有办法把特殊的&nbsp;<code>$</code>&nbsp;字符给转义掉呢？答案是否定的（至少到目前最新的 Nginx 稳定版&nbsp;<code>1.0.10</code>）。不过幸运的是，我们可以绕过这个限制，比如通过不支持&ldquo;变量插值&rdquo;的模块配置指令专门构造出取值为&nbsp;<code>$</code>&nbsp;的 Nginx 变量，然后再在&nbsp;<a href="http://wiki.nginx.org/HttpEchoModule#echo" rel="external nofollow noreferrer">echo</a>&nbsp;中使用这个变量。看下面这个例子：</p>
<div>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://wiki.nginx.org/NginxHttpGeoModule#geo" rel="external nofollow noreferrer">geo</a>&nbsp;$dollar&nbsp;{<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;default&nbsp;"$";<br />&nbsp;&nbsp;&nbsp;&nbsp;}<br />&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://wiki.nginx.org/NginxHttpCoreModule#server" rel="external nofollow noreferrer">server</a>&nbsp;{<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://wiki.nginx.org/NginxHttpCoreModule#listen" rel="external nofollow noreferrer">listen</a>&nbsp;8080;<br />&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://wiki.nginx.org/NginxHttpCoreModule#location" rel="external nofollow noreferrer">location</a>&nbsp;/test&nbsp;{<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;echo&nbsp;"This&nbsp;is&nbsp;a&nbsp;dollar&nbsp;sign:&nbsp;$dollar";<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />&nbsp;&nbsp;&nbsp;&nbsp;}</pre>
</div>
<p>测试结果如下：</p>
<div>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;$&nbsp;curl&nbsp;'http://localhost:8080/test'<br />&nbsp;&nbsp;&nbsp;&nbsp;This&nbsp;is&nbsp;a&nbsp;dollar&nbsp;sign:&nbsp;$</pre>
</div>
<p>这里用到了标准模块&nbsp;<a href="http://wiki.nginx.org/HttpGeoModule" rel="external nofollow noreferrer">ngx_geo</a>&nbsp;提供的配置指令&nbsp;<a href="http://wiki.nginx.org/HttpGeoModule#geo" rel="external nofollow noreferrer">geo</a>&nbsp;来为变量&nbsp;<code>$dollar</code>&nbsp;赋予字符串&nbsp;<code>"$"</code>，这样我们在下面需要使用美元符的地方，就直接引用我们的&nbsp;<code>$dollar</code>&nbsp;变量就可以了。其实&nbsp;<a href="http://wiki.nginx.org/HttpGeoModule" rel="external nofollow noreferrer">ngx_geo</a>&nbsp;模块最常规的用法是根据客户端的 IP 地址对指定的 Nginx 变量进行赋值，这里只是借用它以便&ldquo;无条件地&rdquo;对我们的&nbsp;<code>$dollar</code>&nbsp;变量赋予&ldquo;美元符&rdquo;这个值。</p>
<p>在&ldquo;变量插值&rdquo;的上下文中，还有一种特殊情况，即当引用的变量名之后紧跟着变量名的构成字符时（比如后跟字母、数字以及下划线），我们就需要使用特别的记法来消除歧义，例如：</p>
<div>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://wiki.nginx.org/NginxHttpCoreModule#server" rel="external nofollow noreferrer">server</a>&nbsp;{<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://wiki.nginx.org/NginxHttpCoreModule#listen" rel="external nofollow noreferrer">listen</a>&nbsp;8080;<br />&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://wiki.nginx.org/NginxHttpCoreModule#location" rel="external nofollow noreferrer">location</a>&nbsp;/test&nbsp;{<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://wiki.nginx.org/NginxHttpRewriteModule#set" rel="external nofollow noreferrer">set</a>&nbsp;$first&nbsp;"hello&nbsp;";<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;echo&nbsp;"${first}world";<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />&nbsp;&nbsp;&nbsp;&nbsp;}</pre>
</div>
<p>这里，我们在&nbsp;<a href="http://wiki.nginx.org/HttpEchoModule#echo" rel="external nofollow noreferrer">echo</a>&nbsp;配置指令的参数值中引用变量&nbsp;<code>$first</code>&nbsp;的时候，后面紧跟着&nbsp;<code>world</code>&nbsp;这个单词，所以如果直接写作&nbsp;<code>"$firstworld"</code>&nbsp;则 Nginx &ldquo;变量插值&rdquo;计算引擎会将之识别为引用了变量&nbsp;<code>$firstworld</code>. 为了解决这个难题，Nginx 的字符串记法支持使用花括号在&nbsp;<code>$</code>&nbsp;之后把变量名围起来，比如这里的&nbsp;<code>${first}</code>. 上面这个例子的输出是：</p>
<div>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;$&nbsp;curl&nbsp;'http://localhost:8080/test<br />&nbsp;&nbsp;&nbsp;&nbsp;hello&nbsp;world</pre>
</div>
<p><a href="http://wiki.nginx.org/HttpRewriteModule#set" rel="external nofollow noreferrer">set</a>&nbsp;指令（以及前面提到的&nbsp;<a href="http://wiki.nginx.org/HttpGeoModule#geo" rel="external nofollow noreferrer">geo</a>&nbsp;指令）不仅有赋值的功能，它还有创建 Nginx 变量的副作用，即当作为赋值对象的变量尚不存在时，它会自动创建该变量。比如在上面这个例子中，如果&nbsp;<code>$a</code>&nbsp;这个变量尚未创建，则&nbsp;<code>set</code>&nbsp;指令会自动创建&nbsp;<code>$a</code>&nbsp;这个用户变量。如果我们不创建就直接使用它的值，则会报错。例如</p>
<div>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;?&nbsp;<a href="http://wiki.nginx.org/NginxHttpCoreModule#server" rel="external nofollow noreferrer">server</a>&nbsp;{<br />&nbsp;&nbsp;&nbsp;&nbsp;?&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://wiki.nginx.org/NginxHttpCoreModule#listen" rel="external nofollow noreferrer">listen</a>&nbsp;8080;<br />&nbsp;&nbsp;&nbsp;&nbsp;?<br />&nbsp;&nbsp;&nbsp;&nbsp;?&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://wiki.nginx.org/NginxHttpCoreModule#location" rel="external nofollow noreferrer">location</a>&nbsp;/bad&nbsp;{<br />&nbsp;&nbsp;&nbsp;&nbsp;?&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;echo&nbsp;$foo;<br />&nbsp;&nbsp;&nbsp;&nbsp;?&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />&nbsp;&nbsp;&nbsp;&nbsp;?&nbsp;}</pre>
</div>
<p>此时 Nginx 服务器会拒绝加载配置:</p>
<div>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;[emerg]&nbsp;unknown&nbsp;"foo"&nbsp;variable</pre>
</div>
<p>是的，我们甚至都无法启动服务！</p>
<p>有趣的是，Nginx 变量的创建和赋值操作发生在全然不同的时间阶段。Nginx 变量的创建只能发生在 Nginx 配置加载的时候，或者说 Nginx 启动的时候；而赋值操作则只会发生在请求实际处理的时候。这意味着不创建而直接使用变量会导致启动失败，同时也意味着我们无法在请求处理时动态地创建新的 Nginx 变量。</p>
<p>Nginx 变量一旦创建，其变量名的可见范围就是整个 Nginx 配置，甚至可以跨越不同虚拟主机的&nbsp;<code>server</code>配置块。我们来看一个例子：</p>
<div>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://wiki.nginx.org/NginxHttpCoreModule#server" rel="external nofollow noreferrer">server</a>&nbsp;{<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://wiki.nginx.org/NginxHttpCoreModule#listen" rel="external nofollow noreferrer">listen</a>&nbsp;8080;<br />&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://wiki.nginx.org/NginxHttpCoreModule#location" rel="external nofollow noreferrer">location</a>&nbsp;/foo&nbsp;{<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;echo&nbsp;"foo&nbsp;=&nbsp;[$foo]";<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://wiki.nginx.org/NginxHttpCoreModule#location" rel="external nofollow noreferrer">location</a>&nbsp;/bar&nbsp;{<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://wiki.nginx.org/NginxHttpRewriteModule#set" rel="external nofollow noreferrer">set</a>&nbsp;$foo&nbsp;32;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;echo&nbsp;"foo&nbsp;=&nbsp;[$foo]";<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br />&nbsp;&nbsp;&nbsp;&nbsp;}</pre>
</div>
<p>这里我们在&nbsp;<code>location /bar</code>&nbsp;中用&nbsp;<code>set</code>&nbsp;指令创建了变量&nbsp;<code>$foo</code>，于是在整个配置文件中这个变量都是可见的，因此我们可以在&nbsp;<code>location /foo</code>&nbsp;中直接引用这个变量而不用担心 Nginx 会报错。</p>
<p>下面是在命令行上用&nbsp;<code>curl</code>&nbsp;工具访问这两个接口的结果：</p>
<div>
<pre class="prettyprint linenums">&nbsp;&nbsp;&nbsp;&nbsp;$&nbsp;curl&nbsp;'http://localhost:8080/foo'<br />&nbsp;&nbsp;&nbsp;&nbsp;foo&nbsp;=&nbsp;[]<br />&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;$&nbsp;curl&nbsp;'http://localhost:8080/bar'<br />&nbsp;&nbsp;&nbsp;&nbsp;foo&nbsp;=&nbsp;[32]<br />&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;$&nbsp;curl&nbsp;'http://localhost:8080/foo'<br />&nbsp;&nbsp;&nbsp;&nbsp;foo&nbsp;=&nbsp;[]</pre>
</div>
<p>从这个例子我们可以看到，<code>set</code>&nbsp;指令因为是在&nbsp;<code>location /bar</code>&nbsp;中使用的，所以赋值操作只会在访问&nbsp;<code>/bar</code>&nbsp;的请求中执行。而请求&nbsp;<code>/foo</code>&nbsp;接口时，我们总是得到空的&nbsp;<code>$foo</code>&nbsp;值，因为用户变量未赋值就输出的话，得到的便是空字符串。</p>
<p>从这个例子我们可以窥见的另一个重要特性是，Nginx 变量名的可见范围虽然是整个配置，但每个请求都有所有变量的独立副本，或者说都有各变量用来存放值的容器的独立副本，彼此互不干扰。比如前面我们请求了<code>/bar</code>&nbsp;接口后，<code>$foo</code>&nbsp;变量被赋予了值&nbsp;<code>32</code>，但它丝毫不会影响后续对&nbsp;<code>/foo</code>&nbsp;接口的请求所对应的&nbsp;<code>$foo</code>&nbsp;值（它仍然是空的！），因为各个请求都有自己独立的&nbsp;<code>$foo</code>&nbsp;变量的副本。</p>
<p>对于 Nginx 新手来说，最常见的错误之一，就是将 Nginx 变量理解成某种在请求之间全局共享的东西，或者说&ldquo;全局变量&rdquo;。而事实上，Nginx 变量的生命期是不可能跨越请求边界的。</p>
<p>（未完待续）</p>
<p>from:http://blog.sina.com.cn/s/blog_6d579ff40100wi7p.html</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwd60z8.html">线性插值&amp;amp&semi;双线性插值&amp;amp&semi;三线性插值</a>
		</li>
						<li><a href="https://www.batexi.com/a/4950vr08.html">获取系统中所有进程&amp;amp&semi;线程信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gpx0z9.html">使用github之前的技能准备</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4mxk5q.html">Centos7 关闭防火墙（Firewalld ），使用防火墙（iptables）</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q22gg3q.html">《Android深度探索HAL与驱动开发》第二章阅读心得</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gv1279.html">linux 知识汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93mdxz8.html">ActiveReports 报表应用教程 &lpar;7&rpar;---交叉报表及数据透视图实现方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vpoon8.html">SQL2008 R2 主从数据库同步设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdm7wl8.html">09&lowbar;linux下安装Nvidia显卡驱动</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ye2znq.html">【转载】Android Studio jar、so、library项目依赖，原文链接http&colon;&sol;&sol;zhengxiaopeng&period;com&sol;2014&sol;12&sol;13&sol;Android-Studio-jar、so、library项目依赖&sol;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zmmrx9.html">CSS中怎么让DIV居中&lpar;转载&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yyprr8.html">（摘录）SQL Server 存储过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkol1z8.html">&lbrack;Unity Shader&rsqb;光照模型对物体的假设</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv16m11q.html">Git - git clone - 将远端仓库克隆拷贝到本地</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyd0pe9.html">red&lpar;&rpar;、redinle&lpar;&rpar;、redlines&lpar;&rpar;三者之间的关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp35239.html">jquery 实现tab切换</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy61lmq.html">laravel command调用方法命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1rjg1q.html">PHP实现删除非站内外部链接实例代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25levvq.html">keepalived与zookeeper</a>
		</li>
						<li><a href="https://www.batexi.com/a/960w6m49.html">jvm：垃圾收集器</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pj0pv49.html">1．Perl基础系列之WHAT、WHY、HOW</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xejx09.html">ubuntu studio</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj0k4z9.html">MySQL库目录下db&period;opt文件的作用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1y2j69.html">使用univocity-parsers创建和读取csv文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x4d7z8.html">Subsets 解答</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1dlyn9.html">hpux操作系统的关机与重新启动命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmg7269.html">SSCTF Final PWN</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv6ovzq.html">克隆虚拟机，如何将克隆虚拟的网卡设置为eth0</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm20xl9.html">js执行环境深入研究</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2won4wq.html">android&mdash;&mdash;fragment长时间home或者锁屏java&period;lang&period;IllegalArgumentException：No view found for id for&period;&period;&period;&period;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
